Coin: SbBox3i32 Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Protected Attributes | Related Symbols | List of all members
SbBox3i32 Class Reference
Base Classes

The SbBox3i32 class is a 3 dimensional box with 32-bit integer coordinates. More...

`#include <Inventor/SbBox3i32.h>`

## Public Member Functions
| SbBox3i32 (void)
| SbBox3i32 (int32_t xmin, int32_t ymin, int32_t zmin, int32_t xmax, int32_t ymax, int32_t zmax)
| SbBox3i32 (const SbVec3i32 &minpoint, const SbVec3i32 &maxpoint)
| SbBox3i32 (const SbBox3s &box)
| SbBox3i32 (const SbBox3f &box)
| SbBox3i32 (const SbBox3d &box)
SbBox3i32 & | setBounds (int32_t xmin, int32_t ymin, int32_t zmin, int32_t xmax, int32_t ymax, int32_t zmax)
SbBox3i32 & | setBounds (const SbVec3i32 &minpoint, const SbVec3i32 &maxpoint)
SbBox3i32 & | setBounds (const SbBox3s &box)
SbBox3i32 & | setBounds (const SbBox3f &box)
SbBox3i32 & | setBounds (const SbBox3d &box)
void | getBounds (int32_t &xmin, int32_t &ymin, int32_t &zmin, int32_t &xmax, int32_t &ymax, int32_t &zmax) const
void | getBounds (SbVec3i32 &minpoint, SbVec3i32 &maxpoint) const
const SbVec3i32 & | getMin (void) const
SbVec3i32 & | getMin (void)
const SbVec3i32 & | getMax (void) const
SbVec3i32 & | getMax (void)
void | extendBy (const SbVec3i32 &point)
void | extendBy (const SbBox3i32 &box)
void | extendBy (const SbVec3f &point)
void | transform (const SbMatrix &m)
void | makeEmpty (void)
SbBool | isEmpty (void) const
SbBool | hasVolume (void) const
float | getVolume (void) const
SbBool | intersect (const SbVec3i32 &point) const
SbBool | intersect (const SbBox3i32 &box) const
SbBool | intersect (const SbVec3f &point) const
SbBool | outside (const SbMatrix &mvp, int &cullBits) const
SbVec3f | getClosestPoint (const SbVec3f &point) const
SbVec3f | getCenter (void) const
void | getOrigin (int32_t &originX, int32_t &originY, int32_t &originZ) const
void | getSize (int32_t &sizeX, int32_t &sizeY, int32_t &sizeZ) const
SbVec3i32 | getSize (void) const
void | getSpan (const SbVec3f &direction, float &dmin, float &dmax) const

## Protected Attributes
SbVec3i32 | minpt
SbVec3i32 | maxpt

## Related Symbols
(Note that these are not member symbols.)
int | operator== (const SbBox3i32 &b1, const SbBox3i32 &b2)
int | operator!= (const SbBox3i32 &b1, const SbBox3i32 &b2)

## Detailed Description

The SbBox3i32 class is a 3 dimensional box with 32-bit integer coordinates.

This box class is used by other classes in Coin for data exchange. It provides storage for two box corners with 32-bit integer coordinates, which is among other things useful for representing screen or canvas areas in absolute window coordinates.

See also
  SbBox2f, SbBox2d, SbBox3s, SbBox3f, SbBox3d, SbXfBox3f.

## Constructor & Destructor Documentation

## ◆ SbBox3i32() [1/6]

SbBox3i32::SbBox3i32 | ( | void |  | ) |
| inline

The default constructor makes an empty box.

## ◆ SbBox3i32() [2/6]

SbBox3i32::SbBox3i32 | ( | int32_t | xmin,
|  | int32_t | ymin,
|  | int32_t | zmin,
|  | int32_t | xmax,
|  | int32_t | ymax,
|  | int32_t | zmax )
| inline

Constructs a box with the given corners.

xmin should be less than xmax, ymin should be less than ymax and zmin should be less than zmax if you want to make a valid box.

## ◆ SbBox3i32() [3/6]

SbBox3i32::SbBox3i32 | ( | const SbVec3i32 & | minpoint,
|  | const SbVec3i32 & | maxpoint )
| inline

Constructs a box with the given corners.

The coordinates of minpoint should be less than the coordinates of maxpoint if you want to make a valid box.

## ◆ SbBox3i32() [4/6]

SbBox3i32::SbBox3i32 | ( | const SbBox3s & | box | ) |
| inlineexplicit

Constructs an SbBox3i32 instance from the value in an SbBox3s instance.

Since
  Coin 2.5

## ◆ SbBox3i32() [5/6]

SbBox3i32::SbBox3i32 | ( | const SbBox3f & | box | ) |
| inlineexplicit

Constructs an SbBox3i32 instance from the value in an SbBox3f instance.

Since
  Coin 2.5

## ◆ SbBox3i32() [6/6]

SbBox3i32::SbBox3i32 | ( | const SbBox3d & | box | ) |
| inlineexplicit

Constructs an SbBox3i32 instance from the value in an SbBox3d instance.

Since
  Coin 2.5

## Member Function Documentation

## ◆ setBounds() [1/5]

SbBox3i32 & SbBox3i32::setBounds | ( | int32_t | xmin,
|  | int32_t | ymin,
|  | int32_t | zmin,
|  | int32_t | xmax,
|  | int32_t | ymax,
|  | int32_t | zmax )
| inline

Reset the boundaries of the box.

xmin should be less than xmax, ymin should be less than ymax and zmin should be less than zmax if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [2/5]

SbBox3i32 & SbBox3i32::setBounds | ( | const SbVec3i32 & | minpoint,
|  | const SbVec3i32 & | maxpoint )
| inline

Reset the boundaries of the box with the given corners.

The coordinates of minpoint should be less than the coordinates of maxpoint if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [3/5]

SbBox3i32 & SbBox3i32::setBounds | ( | const SbBox3s & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds()

## ◆ setBounds() [4/5]

SbBox3i32 & SbBox3i32::setBounds | ( | const SbBox3f & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds()

## ◆ setBounds() [5/5]

SbBox3i32 & SbBox3i32::setBounds | ( | const SbBox3d & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds()

## ◆ getBounds() [1/2]

void SbBox3i32::getBounds | ( | int32_t & | xmin,
|  | int32_t & | ymin,
|  | int32_t & | zmin,
|  | int32_t & | xmax,
|  | int32_t & | ymax,
|  | int32_t & | zmax ) const
| inline

Returns the box boundaries.

See also
  setBounds().

## ◆ getBounds() [2/2]

void SbBox3i32::getBounds | ( | SbVec3i32 & | minpoint,
|  | SbVec3i32 & | maxpoint ) const
| inline

Returns the box corner points.

See also
  setBounds().

## ◆ getMin() [1/2]

const SbVec3i32 & SbBox3i32::getMin | ( | void |  | ) | const
| inline

Returns the minimum point. This should usually be the lower left corner point of the box.

See also
  getOrigin(), getMax().

## ◆ getMin() [2/2]

SbVec3i32 & SbBox3i32::getMin | ( | void |  | ) |
| inline

Returns a modifiable reference to the minimum point.

## ◆ getMax() [1/2]

const SbVec3i32 & SbBox3i32::getMax | ( | void |  | ) | const
| inline

Returns the maximum point. This should usually be the upper right corner point of the box.

See also
  getMin().

## ◆ getMax() [2/2]

SbVec3i32 & SbBox3i32::getMax | ( | void |  | ) |
| inline

Returns a modifiable reference to the maximum point.

## ◆ extendBy() [1/3]

void SbBox3i32::extendBy | ( | const SbVec3i32 & | point | ) |

Extend the boundaries of the box by the given point, i.e. make the point fit inside the box if it isn't already within it.

## ◆ extendBy() [2/3]

void SbBox3i32::extendBy | ( | const SbBox3i32 & | box | ) |

Extend the boundaries of the box by the given box parameter. This is equal to calling extendBy() twice with the corner points.

## ◆ extendBy() [3/3]

void SbBox3i32::extendBy | ( | const SbVec3f & | point | ) |

Extend the boundaries of the box by the given point, i.e. make the point fit inside the box if it isn't already within it.

## ◆ transform()

void SbBox3i32::transform | ( | const SbMatrix & | matrix | ) |

Transform the box by the matrix, and change its boundaries to contain the transformed box.

Doesn't touch illegal/empty boxes.

## ◆ makeEmpty()

void SbBox3i32::makeEmpty | ( | void |  | ) |

Marks this as an empty box.

See also
  isEmpty().

## ◆ isEmpty()

SbBool SbBox3i32::isEmpty | ( | void |  | ) | const
| inline

Check if this has been marked as an empty box.

See also
  makeEmpty().

## ◆ hasVolume()

SbBool SbBox3i32::hasVolume | ( | void |  | ) | const
| inline

Check if the box has been correctly specified and by that virtue has "positive" volume, i.e. all coordinates of its upper right corner (the maximum point) are greater than the corresponding coordinates of its lower left corner (the minimum point).

## ◆ getVolume()

float SbBox3i32::getVolume | ( | void |  | ) | const
| inline

Returns the volume of the box.

## ◆ intersect() [1/3]

SbBool SbBox3i32::intersect | ( | const SbVec3i32 & | point | ) | const

Check if the given point lies within the boundaries of this box.

## ◆ intersect() [2/3]

SbBool SbBox3i32::intersect | ( | const SbBox3i32 & | box | ) | const

Check if box lies entirely or partially within the boundaries of this box.

## ◆ intersect() [3/3]

SbBool SbBox3i32::intersect | ( | const SbVec3f & | point | ) | const

Check if the given point lies within the boundaries of this box.

## ◆ outside()

SbBool SbBox3i32::outside | ( | const SbMatrix & | mvp,
|  | int & | cullbits ) const

Check if the box is outside the view volume defined by the mvp matrix. Sets cullbits according to which planes we're inside or outside. Bit 0 (0x1) is cleared when box is completely inside left and right clipping planes. Bit 1 (0x2) is cleared when box is inside top and bottom clipping planes. Bit 2 (0x4) is cleared when box is inside near and far clipping planes.

Returns `TRUE` if box is completely outside one of the clipping planes. `FALSE` otherwise.

## ◆ getClosestPoint()

SbVec3f SbBox3i32::getClosestPoint | ( | const SbVec3f & | point | ) | const

Return the point on the box closest to the given point. If the given point equals the center, the center point of the positive Z face is returned.

## ◆ getCenter()

SbVec3f SbBox3i32::getCenter | ( | void |  | ) | const
| inline

Returns the center point of the box.

## ◆ getOrigin()

void SbBox3i32::getOrigin | ( | int32_t & | originX,
|  | int32_t & | originY,
|  | int32_t & | originZ ) const
| inline

Returns the coordinates of the box origin (i.e. the lower left corner).

See also
  getMin().

## ◆ getSize() [1/2]

void SbBox3i32::getSize | ( | int32_t & | sizeX,
|  | int32_t & | sizeY,
|  | int32_t & | sizeZ ) const
| inline

Returns width, height and depth of box.

## ◆ getSize() [2/2]

SbVec3i32 SbBox3i32::getSize | ( | void |  | ) | const
| inline

Returns width, height and depth of box as a 3D vector.

Since
  Coin 3.0

## ◆ getSpan()

void SbBox3i32::getSpan | ( | const SbVec3f & | dir,
|  | float & | dmin,
|  | float & | dmax ) const

Find the span of the box in the given direction (i.e. how much room in the given direction the box needs). The distance is returned as the minimum and maximum distance from origo to the closest and furthest plane defined by the direction vector and each of the box' corners. The difference between these values gives the span.

## Friends And Related Symbol Documentation

## ◆ operator==()

int operator== | ( | const SbBox3i32 & | b1,
|  | const SbBox3i32 & | b2 )
| related

Check b1 and b2 for equality.

## ◆ operator!=()

int operator!= | ( | const SbBox3i32 & | b1,
|  | const SbBox3i32 & | b2 )
| related

Check b1 and b2 for inequality.

The documentation for this class was generated from the following files:

- SbBox3i32.h
- SbBox3i32.cpp